/**
 * @brief           leds management
 * @file            leds.c
 * @author          <a href="">Dom-IP</a>
 * @dependencies    none
 * @compiler        MPLAB C18 v2.10 or higher <br>
 *                  HITECH PICC-18 V8.35PL3 or higher
 *
 * @section description Description
 **********************************
 * This module contains functions used for the leds management of evaluation boards
 *
 *********************************************************************/

 /*********************************************************************
 * Software License Agreement
 *
 * The software supplied herewith is owned by Benoit Sandre, and is
 * protected under applicable copyright laws.  The code may
 * be modified and can be used free of charge for commercial and non commercial
 * applications. All rights are reserved. Any use in violation of the foregoing
 * restrictions may subject the user to criminal sanctions under applicable laws,
 * as well as to civil liability for the breach of the terms and conditions of this license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN 'AS IS' CONDITION. NO WARRANTIES, WHETHER EXPRESS,
 * IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE
 * COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 **********************************************************************
 * File History
 *
 * 2009-06-01, Dom-IP
 *    - Initial version
 *********************************************************************/

#include "projdefs.h"


/////////////////////////////////////////////////
//Function prototypes
//NA

/////////////////////////////////////////////////


void SetLeds(BYTE Value) {
    BYTE i;
    
	//set the latch command port in output
	LATC0=0;TRISC_RC0=0;
	LATC1=0;TRISC_RC1=0;
	LATC2=1;TRISC_RC2=0;

	//for every bit of Value
    for(i = 0; i <8; i++)    
    {
		LATC0= (Value & 1);
		LATC1=1;LATC1=0;
		Value=Value>>1;
    }
	LATC2=0;LATC2=1;
}



