/*********************************************************************
 * teleinfo.c      -  EDF Teleinfo data receptor
 * Dependencies:    
 * Processor:       PIC18
 * Complier:        MCC18 v1.00.50 or higher
 *  
 *
 *********************************************************************
 * Description
 *
 * Allows the SBC65EC to receive EDF releinformation serial data
 *
 *********************************************************************
 * File History
 *
 * 2009-06-16, Benot Sandr (BS):
 *    - Initial Version
 *
 *********************************************************************
 * Software License Agreement : according GPL 2.0 
 *
 ********************************************************************/


#include "projdefs.h"
#include "serint.h"
#include "net\tick.h"
#include "teleinfo.h"

BYTE trameTeleInfo[TAILLE_MAX_TRAME_TELEINFO];  // buffer used to save teleinfo frame
BYTE statusTeleInfo=TELEINFO_IDLE;  			// variable used to store teleinfo receive status
TICK16 startTimer;  							// Variable used to chek RX timeout

BYTE processTeleInfo() {
static BYTE indexTrame;
BYTE RxByte;
	if (statusTeleInfo==TELEINFO_START_WAITING)  {

		//traitement du timeout
		if (TickGetSecDiff(startTimer) > TELEINFO_TIMEOUT) {
			trameTeleInfo[0]=0;
			statusTeleInfo=TELEINFO_RX_KO;
		}
		//On recupere les infos du compteur
		else while (serIsGetReady() && (statusTeleInfo==TELEINFO_START_WAITING)) {
			RxByte=serGetByte() & 0x7F;
			if (RxByte ==2) {
				indexTrame=0;
				statusTeleInfo=TELEINFO_RECEIVING;
				startTimer=TickGetSec();
			} 
		}
	}
	else if (statusTeleInfo==TELEINFO_RECEIVING) {
		//traitement du timeout
		if (TickGetSecDiff(startTimer) > TELEINFO_TIMEOUT) {
			trameTeleInfo[0]=0;
			statusTeleInfo=TELEINFO_RX_KO;
		}
		//On recupere les infos du compteur
		 else while (serIsGetReady() && (statusTeleInfo==TELEINFO_RECEIVING)) {
			RxByte=serGetByte() & 0x7F;
			if (( RxByte == 3 ) || ( RxByte == 4 )) {
				trameTeleInfo[indexTrame++]=0;
				statusTeleInfo=TELEINFO_RX_OK;
			} else {
				if ( indexTrame !=TAILLE_MAX_TRAME_TELEINFO-2) trameTeleInfo[indexTrame++]=RxByte; 
			}
		}
	}
	return(statusTeleInfo);
}

