/**
 * @brief           teleinfo reception
 * @file            teleinfo.h
 * @author          <a href="">Benot Sandr</a>
 * @dependencies    none
 * @compiler        MPLAB C18 v2.10 or higher <br>
 *                  HITECH PICC-18 V8.35PL3 or higher
 *
 * @section description Description
 **********************************
 * This module contains functions used to get teleinformation frame from an EDF meter
 *
 *********************************************************************/

 /*********************************************************************
 * Software License Agreement
 *
 * according GPL V2.0
 **********************************************************************
 * File History
 *
 * 2009-06-16, Benoit Sandr (DH):
 *    - Initial version
 *********************************************************************/

#ifndef TELEINFO_H
#define TELEINFO_H

#define TAILLE_MAX_TRAME_TELEINFO 170

extern BYTE trameTeleInfo[];
extern BYTE statusTeleInfo;
extern TICK16 startTimer; 

#define START_TELEINFO_RX statusTeleInfo=TELEINFO_START_WAITING;startTimer=TickGetSec();

/* TeleInfo process state definition */

#define TELEINFO_IDLE 0
#define TELEINFO_START_WAITING 1
#define TELEINFO_RECEIVING 2
#define TELEINFO_RX_OK 3
#define TELEINFO_RX_KO 4

/* Teleinfo Timeout in seconds */
#define TELEINFO_TIMEOUT 3

/**
 * Delays for the given time, and checks for any input on the serial port. If anything is received
 * within this time, it enters the serial configuration menu. If not, it returns
 *
 * @param delay     Delay in seconds
 */
BYTE processTeleInfo();

#endif
